<?php
/**************************************************
    AD REVENUE SHARING MOD V1.2 - ManageArs.php
**************************************************/

// ZEROCOOL YOU ARE NOT! DIE DIE DIE
if (!defined('SMF'))
	die('Hacking attempt...');

// OUR FUNCTION
function ManageArs()
{
	global $context, $txt, $scripturl;
	
	// ADMINS ONLY!
	isAllowedTo('admin_forum');

	// THEN LOAD OUR STUFF

	adminIndex('manage_ars');
	loadTemplate('ManageArs');
	loadLanguage('ManageArs');
	$context['page_title'] = $txt['ars_modlongname'];


	// ALL OUR SUBACTIONS AND WHAT FUNCTION/TEMPLATE THAT WILL CALL
	$subActions = array(
		'settings' => 'settingsArs',
		'adsetup' => 'adsetupArs',
		'adshare' => 'adshareArs',
		'reports' => 'reportsArs',
		'credits' => 'creditsArs',
		'help' => 'helpArs',
	);

	// IF THERES NO SUB, WE NEED TO GO TO SUBWAY
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'settings';
	$context['sub_action'] = $_REQUEST['sa'];

	// CREATES THE TABS ON OUR AD REVENUE ADMINISTRATION AREA
	$context['admin_tabs'] = array(
		'title' => $txt['ars_modlongname'],
		'description' => $txt['ars_welcome'],
		'tabs' => array(
			'settings' => array(
				'title' => $txt['ars_settings'],
				'href' => $scripturl . '?action=managears',
			),
			'adsetup' => array(
				'title' => $txt['ars_adsetup'],
				'href' => $scripturl . '?action=managears;sa=adsetup',
			),
			'adshare' => array(
				'title' => $txt['ars_adshare'],
				'href' => $scripturl . '?action=managears;sa=adshare',
			),
			'reports' => array(
				'title' => $txt['ars_reports'],
				'href' => $scripturl . '?action=managears;sa=reports',
			),
			'credits' => array(
				'title' => $txt['ars_credits'],
				'href' => $scripturl . '?action=managears;sa=credits',
				'is_last' => true,
			),
		),
	);

	// SELECTS A TAB
	if (isset($context['admin_tabs']['tabs'][$context['sub_action']]))
		$context['admin_tabs']['tabs'][$context['sub_action']]['is_selected'] = true;
	// Otherwise it's going to be the browse anyway...
	else
		$context['admin_tabs']['tabs']['settings']['is_selected'] = true;
		
	// CALL THE REQUIRED SUBACTION
	$subActions[$_REQUEST['sa']]();

}

// SETTINGS FUNCTION - CALLS THE TEMPLATE
function settingsArs()
{
	global $db_prefix, $context, $txt, $modSettings;

	// IF THERE IS POST DATA TO SAVE, DO SO
	if (isset($_POST['save']))
	{
		
		// OUR MAIN SETTINGS
		$a = array(
			'enabled',
			'useadsense',
			'useypn',
			'usetextlinkads',
			'logimpressions'
			);

		// ### SAVE CHECKBOX SETTINGS ###
		foreach ($a as $b){
 
			// CHECKBOXES ONLY SEND POST DATA IF THEY ARE CHECKED SO IF THE KEY EXISTS, IT IS SET
			$c = isset($_POST['ars_settings_'.$b]) ? 1 : 0;
			// ONLY SAVE IF THE SETTING CHANGED
			if ($modSettings['ars_'.$b] != $c) {
				db_query("
					UPDATE {$db_prefix}settings
					SET value='$c'
					WHERE variable = 'ars_".$b."'", __FILE__, __LINE__);
			}
			// tidy up
			unset($c);
		}
		// tidy up
		unset($a,$b);
		
		
		// TRY TO SAVE BANNED USERS LIST
		$b = "bannedusers";
		
		$d = isset($_POST['ars_settings_'.$b]) ? 1 : 0;
		if ($d) {
			$c = $_POST['ars_settings_'.$b];
			// VALIDATE IT OR RESET TO THE SAVED SETTING - USER IDS SEPARATED BY COMMAS
			$c = (!eregi('[^0-9,]', $c)) ? $c : $modSettings['ars_'.$b] ;
					
			// IF SETTING WAS INVALID OR HAS NOT CHANGED, DON'T SAVE
			if ($modSettings['ars_'.$b] != $c) {
				db_query("
					UPDATE {$db_prefix}settings
					SET value='$c'
					WHERE variable = 'ars_".$b."'", __FILE__, __LINE__);
			}

			// IF THE BANNED USERS LIST ISNT EMPTY, NOW WE'VE SAVED THE LIST, REMOVE ANY BANNED PARTICIPANTS
			if(!empty($c)) {
				// IF CONTAINS COMMA SPLIT BY IT, ELSE SET IN ARRAY SO FOREACH LOOP DOESNT CAUSE ERROR
				$e = (stristr($c,',')) ? explode(',',$c) : array($c);
			
				// NOW FOR EACH BANNED USER, WE WILL CHECK IF IS A PARTICIPANT, IF IS, DELETE THEM FROM PARTICIPANTS
				foreach($e as $f) {
					if ($f != "") {
					
						// CHECK IF PARTICIPANT
					
						$query = db_query("
									SELECT ID_MEMBER
									FROM {$db_prefix}ars_participants
									WHERE ID_MEMBER = '".$f."'", __FILE__, __LINE__);
						$row= mysql_fetch_assoc($query);
						mysql_free_result($query);
						// IF PARTICIPANT, DELETE THEM
						if ($row !== NULL) {
								db_query("
									DELETE FROM {$db_prefix}ars_participants
									WHERE ID_MEMBER = '".$f."'", __FILE__, __LINE__);
						}
					}
				}
			}
		}
			// tidy up
		unset($b,$c,$d,$e,$f);

		// TRY TO SAVE DEFAULT AD SHARE
		$b = "defaultadshare";
		
		$d = isset($_POST['ars_settings_'.$b]) ? 1 : 0;
		if ($d) {
			$c = $_POST['ars_settings_'.$b];
			// VALIDATE IT OR RESET TO THE SAVED SETTING - CANT HAVE BLANK
			$c = (!eregi('[^0-9]', $c)) ? $c : $modSettings['ars_'.$b] ;
					
			// IF SETTING WAS INVALID OR HAS NOT CHANGED, DON'T SAVE
			if ($modSettings['ars_'.$b] != $c) {
				db_query("
					UPDATE {$db_prefix}settings
					SET value='$c'
					WHERE variable = 'ars_".$b."'", __FILE__, __LINE__);
			}
			// tidy up
			unset($c);
		}
		unset($b,$d);
		
		// SAVE ALL THE IDS/STRINGS AND THEIR LENG
		$a = array();
		// ALL THE VALIDATION STRINGS FOR THE EREGI - VERY WELL DONE IF I SAY SO MYSELF
		$a['adsenseid'] = '^(ca-pub-|pub-)+([0-9]{16}$)';
		$a['adsensechannel'] = '^[0-9]{10}$';
		$a['ypnid'] = '^[0-9]{10}$';
		$a['ypnsection'] = '^[0-9]{5}$';
		$a['textlinkadsid'] = '^[0-9a-zA-Z]{6}$';

		// RUN THROUGH EACH SETTING AND TRY TO SAVE
		foreach($a as $b => $v) {

			// CHECK NOT BLANK - TO HELP AVOID INDEX UNDEFINED ERRORS
			if (!empty($_POST['ars_settings_'.$b])) {
				// VALIDATE
				$c = !empty($_POST['ars_settings_'.$b]) ? strtolower($_POST['ars_settings_'.$b]) : '' ;
				$c = eregi($v, $c) ? $c : $modSettings['ars_'.$b] ;
			} else {
				// IF USER WANTS TO REMOVE IT, LET THEM DO SO
				$c = '';
			}
					
			// IF THE SETTING WAS EMPTY INVALID OR HAS NOT CHANGED, DON'T SAVE
			if (empty($modSettings['ars_'.$b]) || ($modSettings['ars_'.$b] != $c)) {
				db_query("
					UPDATE {$db_prefix}settings
					SET value='$c'
					WHERE variable = 'ars_".$b."'", __FILE__, __LINE__);
			}
		}
		// tidy up
		unset($a,$b);

		// ALL SETTINGS SAVED, SO RELOAD TO AVOID RESENDING POST DATA
		redirectexit('action=managears;sa=settings');
	}
	
	$context['sub_template'] = 'settings';
	$context['page_title'] = $txt['ars_settings'];
		
}

// ADSETUP FUNCTION - CALL THE TEMPLATE
function adsetupArs()
{
	global $db_prefix, $context, $txt, $modSettings;
	
	// THERE IS SAVE DATA
	if (isset($_POST['save']))
	{	
		
		// START TO TRY TO SAVE THE CUSTOM COLORS SETTINGS
		
		// ALL THE COLOR SETTINGS
		$a = array("bgcolor", "bordercolor", "linkcolor", "urlcolor", "textcolor");

		// RUN THROUGH AND SAVE EACH AD PLACE AND SAVE THE ENABLED/SIZE/SCHEME SETTINGS
		foreach($a as $b) {
			// CHECK NOT BLANK - TO HELP AVOID INDEX UNDEFINED ERRORS
			$d = isset($_POST['ars_adsetup_'.$b]) ? 1 : 0;
			if ($d == 1) {
				// AVOID UNINITILISED STRING IF IS NULL AND A QUICK VALIDATION OF LENGTH
				if (strlen($_POST['ars_adsetup_'.$b]) == "6") {
					// NOW SAFE TO CALL VAR WITHOUT INDEX UNDEFINED ERROR
					$c = $_POST['ars_adsetup_'.$b];
					$c = (eregi('^[0-9a-fA-F]{6}$', $c)) ? $c : $modSettings['ars_adsetup_'.$b] ;
				
					// IF SETTING WAS INVALID OR HAS NOT CHANGED, DON'T SAVE
					if ($modSettings['ars_adsetup_'.$b] != $c) {
						db_query("
							UPDATE {$db_prefix}settings
							SET value='$c'
							WHERE variable = 'ars_adsetup_".$b."'", __FILE__, __LINE__);
					}

					// tidy up
					unset($c);
				}
			}
			// tidy up
			unset($d);
		}
		// tidy up
		unset($a,$b);

		// TEXT LINK AD SETTING - EASY TO SAVE
		$b = 'textlinkadsstyle';
		$d = isset($_POST['ars_adsetup_'.$b]) ? 1 : 0;
		if ($d == 1) {
			$c = $_POST['ars_adsetup_'.$b];
			// VALIDATE IT OR RESET TO THE SAVED SETTING - CANT HAVE BLANK
			$c = (eregi('^[A-FZ]{1}$', $c)) ? $c : $modSettings['ars_adsetup_'.$b] ;
					
			// IF SETTING WAS INVALID OR HAS NOT CHANGED, DON'T SAVE
			if ($modSettings['ars_adsetup_'.$b] != $c) {
								db_query("
									UPDATE {$db_prefix}settings
									SET value='$c'
									WHERE variable = 'ars_adsetup_".$b."'", __FILE__, __LINE__);
			}
			// tidy up
			unset($c);
		}
		// tidy up
		unset($b,$d);

		// START TO TRY TO SAVE THE AD SELECTION SETTINGS

		// ALL THE AD PLACES
		$a = array('top', 'bottom', 'links', 'welcome', 'post','left', 'right', 'sidebars', 'tables');
		
		// RUN THROUGH AND SAVE EACH AD PLACE AND SAVE THE ENABLED/SIZE/SCHEME SETTINGS
		foreach($a as $b) {

			// ### SAVE CHECKBOX SETTING ###
 
			// CHECKBOXES ONLY SEND POST DATA IF THEY ARE CHECKED SO IF THE KEY EXISTS, IT IS SET
			$c = isset($_POST['ars_adsetup_'.$b.'_enabled']) ? 1 : 0;
			// ONLY SAVE IF THE SETTING CHANGED
			if ($modSettings['ars_adsetup_'.$b.'_enabled'] != $c) {
				db_query("
					UPDATE {$db_prefix}settings
					SET value='$c'
					WHERE variable = 'ars_adsetup_".$b."_enabled'", __FILE__, __LINE__);
			}
			// tidy up
			unset($c);

			// ### VALIDATE AND SAVE SIZE SETTING ### 
			$d = array(
						'728x90','468x60','234x60','125x125','120x600',
						'160x600','120x240','180x150','120x90'
					);

			$c = $_POST['ars_adsetup_'.$b.'_size'];
			if(in_array($c, $d)) {
			// ONLY SAVE IF THE SETTING CHANGED
				if ($modSettings['ars_adsetup_'.$b.'_size'] != $c) {
					db_query("
						UPDATE {$db_prefix}settings
						SET value='$c'
						WHERE variable = 'ars_adsetup_".$b."_size'", __FILE__, __LINE__);
				}
				// tidy up
				unset($c,$d);
			}

			// ### VALIDATE AND SAVE SCHEME SETTING ### 
			$d = array(
						'default','random','custom','red','orange',
						'yellow','green','blue','pink','black','white'
					);

			$c = $_POST['ars_adsetup_'.$b.'_scheme'];
			if(in_array($c, $d)) {
			// ONLY SAVE IF THE SETTING CHANGED
				if ($modSettings['ars_adsetup_'.$b.'_scheme'] != $c) {
					db_query("
						UPDATE {$db_prefix}settings
						SET value='$c'
						WHERE variable = 'ars_adsetup_".$b."_scheme'", __FILE__, __LINE__);
				}
				// tidy up
				unset($c,$d);
			}

		}
		// tidy up
		unset($a,$b);
		
		// FINISHED SAVING SO REDIRECT TO AVOID META REFRESH RESENDING WARNINGS
		redirectexit('action=managears;sa=adsetup');

	}

	// AFTER SAVING OR IF NOT SAVING, GO AHEAD AND LOAD THE TEMPLATE
	$context['sub_template'] = 'adsetupArs';
	$context['page_title'] = $txt['ars_adsetup'];
}

// ADSHARE FUNCTION - CALLS THE TEMPLATE
function adshareArs()
{
	global $db_prefix, $context, $txt , $membergroups;
	
		// IF THERE IS POST DATA TO SAVE, DO SO
	if (isset($_POST['save']))
	{
		// QUERY THE INFORMATION, WE CAN THEN CHECK FOR CHANGES BEFORE
		$query = db_query("
					SELECT ID_GROUP, ars_share, ars_random, ars_enabled, ars_showads
					FROM {$db_prefix}membergroups
					ORDER BY ID_GROUP", __FILE__, __LINE__);
		
		// LIST THE VARIOUS SETTINGS WE HAVE FOR EACH MEMBERGROUP
		while ($row = mysql_fetch_assoc($query))
		{
			$a = array('random','enabled','showads');
			$saveSettings = array();
			$changes = 0;
			// ### SAVE CHECKBOX SETTINGS ###
			foreach($a as $b) {

				// CHECKBOXES ONLY SEND POST DATA IF THEY ARE CHECKED SO IF THE KEY EXISTS, IT IS SET
				$c = isset($_POST['ars_'.$b.'_'.$row['ID_GROUP']]) ? 1 : 0;
				// ONLY SAVE IF THE SETTING CHANGED
				if ($row['ars_'.$b] != $c) {
					$saveSettings[] = "ars_".$b." = '".$c."'";
					$changes = 1;
				}
				// tidy up
				unset($c);
				
			}
			// tidy up
			unset($a,$b);

			// TRY TO SAVE THE ADSHARE FOR THE MEMBERGROUP
			$b = "share";
			
			$d = isset($_POST['ars_'.$b.'_'.$row['ID_GROUP']]) ? 1 : 0;
			if ($d == 1) {
				$c = $_POST['ars_'.$b.'_'.$row['ID_GROUP']];
				// VALIDATE IT OR RESET TO THE SAVED SETTING - CANT HAVE BLANK
				$c = (!eregi('[^0-9]', $c)) ? $c : $row['ars_'.$b] ;
						
				// ADD THE SETTING TO THE ARRAY TO BE SAVED IF IT HAS CHANGED AND IS VALID
				if ($row['ars_'.$b] != $c) {
					$saveSettings[] = "ars_".$b." = '".$c."'";
					$changes = 1;
				}
				// tidy up
				unset($c);
			}
			unset($b,$d);

			// NOW IF THERE WERE CHANGES
			if ($changes == 1) {
			db_query("
						UPDATE {$db_prefix}membergroups
						SET ". implode(", 
				", $saveSettings) . "
						WHERE ID_GROUP = '".$row['ID_GROUP']."'", __FILE__, __LINE__);
			
			}
			// tidy up
			unset($a,$b,$changes,$saveSettings);
			
		
		}
		mysql_free_result($query);
		
		redirectexit('action=managears;sa=adshare');
	
	}
	
	// QUERY DB FOR MEMBERGROUP INFO WE REQUIRE
	$query = db_query("
	SELECT *
	FROM {$db_prefix}membergroups
	ORDER BY minPosts", __FILE__, __LINE__);
	
	$membergroups = array();
	while($row = mysql_fetch_assoc($query)) {
		$membergroups[] = $row;
	}
	mysql_free_result($query);
	
	$context['sub_template'] = 'adshareArs';
	$context['page_title'] = $txt['ars_adshare'];
	
}

// REPORTS FUNCTION - CALLS THE TEMPLATE
// THIS BIT USES SOME SMF CODE FROM MEMBERLIST.PHP TO SHOW THE PARTICIPANTS - THOSE ARE COPYRIGHT SMF,
function reportsArs()
{
	global $scripturl, $db_prefix, $context, $txt, $participants, $modSettings;
	
	// COUNT THE NO OF PARTICIPANTS
	$query = db_query("
						SELECT COUNT(*)
						FROM {$db_prefix}ars_participants", __FILE__, __LINE__);
	
	list ($context['ars_participants']) = mysql_fetch_row($query);
	mysql_free_result($query);
	
	if (!is_numeric($_REQUEST['start']))
	{
		if (preg_match('~^[^\'\\\\/]~' . ($context['utf8'] ? 'u' : ''), ($_REQUEST['start'] === 0)))
			fatal_error('Hacker?', false);

		$_REQUEST['start'] = $match[0];

		$query = db_query("
							SELECT COUNT(*)
							FROM {$db_prefix}ars_participants
							WHERE LOWER(SUBSTRING(ID_MEMBER, 1, 1)) < ".$_REQUEST['start'], __FILE__, __LINE__);
		list ($_REQUEST['start']) = mysql_fetch_row($query);
		mysql_free_result($query);
	}

	// WHERE TO START/END IN THE PARTICIPANTS
	$context['start'] = $_REQUEST['start'] + 1;
	$context['end'] = min($_REQUEST['start'] + $modSettings['defaultMaxMembers'], $context['ars_participants']);

	// COUNT THE TOTAL NO OF USER IMPRESSIONS
	$query = db_query("
						SELECT impressions
						FROM {$db_prefix}ars_participants", __FILE__, __LINE__);
	$context['ars_userimpressions'] = 0;

	while ($row = mysql_fetch_assoc($query)) {
		$context['ars_userimpressions'] = $context['ars_userimpressions'] + $row['impressions'];
	}
	mysql_free_result($query);

	// Construct the page index.
	$context['page_index'] = constructPageIndex($scripturl . '?action=managears;sa=reports', $_REQUEST['start'], $context['ars_participants'], $modSettings['defaultMaxMembers']);


	// SELECT THE MEMBERS FOR THE CURRENT PAGE
		// ONLY REQUESTS THE DEFAULT MAX MEMBERS AMOUNT (A DEFAULT SMF SETTING FOR MEMBERLIST)
	$query = db_query("
						SELECT p.ID_MEMBER, p.impressions, m.ID_GROUP, m.additionalGroups, m.ID_POST_GROUP, m.memberName
						FROM {$db_prefix}ars_participants AS p
							JOIN {$db_prefix}members AS m ON (m.ID_MEMBER = p.ID_MEMBER)
						ORDER BY impressions DESC
						LIMIT ".$_REQUEST['start'].", ".$modSettings['defaultMaxMembers'], __FILE__, __LINE__);

	// STORE THE PARTICIPANTS IN AN ARRAY FOR USE IN THE TEMPLATE
	$participants = array();

	while ($row = mysql_fetch_assoc($query)) {
		$participants[] = $row;
	}
	mysql_free_result($query);

	// NOW CALL THE TEMPLATE TO SHOW THE PAGE
	$context['sub_template'] = 'reportsArs';
	$context['page_title'] = $txt['ars_reports'];
	
}

// CREDITS FUNCTION - CALLS THE TEMPLATE
function creditsArs()
{
	global $db_prefix, $context, $txt;
	
	// NOTHING TO SEE/DO HERE, SO JUST LOAD THE TEMPLATE
	
	$context['sub_template'] = 'creditsArs';
	$context['page_title'] = $txt['ars_credits'];
	
}

// THIS IS SLIGHTLY MODIFIED SMF CODE - COPYRIGHT SMF
// HELP FUNCTION - CALLS THE TEMPLATE/POPUP - SUIT YOU SIR!
// INCLUDES SECURITY FIX
function helpArs()
{
	global $txt, $helptxt, $context;

	// What help string should be used?
	if (isset($helptxt[$_GET['help']]))
		$context['help_text'] = &$helptxt[$_GET['help']];
	elseif (isset($txt[$_GET['help']]))
		$context['help_text'] = &$txt[$_GET['help']];
	else
		$context['help_text'] = 'Empty';
		
	// Set the page title to something relevant.
	$context['page_title'] = $helptxt['ars_help'];

	// Don't show any template layers, just the popup sub template.
	$context['template_layers'] = array();
	$context['sub_template'] = 'helpArs';
	
}

?>